Index: data/trunk/gui/imagesets/PickupInventory.imageset
===================================================================
--- data/trunk/gui/imagesets/PickupInventory.imageset	(revision 10687)
+++ data/trunk/gui/imagesets/PickupInventory.imageset	(revision 10691)
@@ -10,4 +10,6 @@
     <Image Name="UsePickup" XPos="500" YPos="0" Width="100" Height="100"/>
     <Image Name="DropPickup" XPos="600" YPos="0" Width="100" Height="100"/>
+    <Image Name="DestroyPickup" XPos="1900" YPos="0" Width="100" Height="100"/>
+    <Image Name="DestroyCarrierPickup" XPos="2000" YPos="0" Width="100" Height="100"/>    
 
     <Image Name="SmallInvisible" XPos="700" YPos="0" Width="100" Height="100"/>
@@ -26,3 +28,11 @@
     <Image Name="MediumShrink" XPos="1700" YPos="0" Width="100" Height="100"/>
     <Image Name="HugeShrink" XPos="1800" YPos="0" Width="100" Height="100"/>
+
+    <Image Name="SmallDamageBoost" XPos="2100" YPos="0" Width="100" Height="100"/>
+    <Image Name="MediumDamageBoost" XPos="2200" YPos="0" Width="100" Height="100"/>
+    <Image Name="HugeDamageBoost" XPos="2300" YPos="0" Width="100" Height="100"/>
+
+    <Image Name="SmallMunition" XPos="2400" YPos="0" Width="100" Height="100"/>
+    <Image Name="MediumMunition" XPos="2500" YPos="0" Width="100" Height="100"/>
+    <Image Name="HugeMunition" XPos="2600" YPos="0" Width="100" Height="100"/>
 </Imageset>
Index: data/trunk/materials/3arrowsup.material
===================================================================
--- data/trunk/materials/3arrowsup.material	(revision 10687)
+++ 	(revision )
@@ -1,17 +1,0 @@
-material 3arrowsup
-{
-	technique
-	{
-		pass
-		{
-			lighting off
-			scene_blend add
-			depth_write off
-
-			texture_unit
-			{
-				texture 3arrowsup.png
-			}
-		}
-	}
-}
Index: data/trunk/materials/Arrow.material
===================================================================
--- data/trunk/materials/Arrow.material	(revision 10687)
+++ 	(revision )
@@ -1,17 +1,0 @@
-material Arrow
-{
-	technique
-	{
-		pass
-		{
-			lighting off
-			scene_blend add
-			depth_write off
-
-			texture_unit
-			{
-				texture arrow.png
-			}
-		}
-	}
-}
Index: data/trunk/materials/Cross.material
===================================================================
--- data/trunk/materials/Cross.material	(revision 10687)
+++ 	(revision )
@@ -1,17 +1,0 @@
-material Cross
-{
-	technique
-	{
-		pass
-		{
-			lighting off
-			scene_blend add
-			depth_write off
-
-			texture_unit
-			{
-				texture cross.png
-			}
-		}
-	}
-}
Index: data/trunk/materials/Eye.material
===================================================================
--- data/trunk/materials/Eye.material	(revision 10687)
+++ 	(revision )
@@ -1,17 +1,0 @@
-material Eye
-{
-	technique
-	{
-		pass
-		{
-			lighting off
-			scene_blend add
-			depth_write off
-
-			texture_unit
-			{
-				texture eye.png
-			}
-		}
-	}
-}
Index: data/trunk/materials/Pickups.material
===================================================================
--- data/trunk/materials/Pickups.material	(revision 10691)
+++ data/trunk/materials/Pickups.material	(revision 10691)
@@ -0,0 +1,215 @@
+material Sphere2
+{
+	technique
+	{
+		pass
+		{
+			lighting off
+			scene_blend add
+			depth_write off
+
+			texture_unit
+			{
+				texture sphere.png
+			}
+		}
+	}
+}
+
+material Unknown
+{
+	technique
+	{
+		pass
+		{
+			lighting off
+			scene_blend add
+			depth_write off
+
+			texture_unit
+			{
+				texture unknown.png
+			}
+		}
+	}
+}
+
+material Damage
+{
+	technique
+	{
+		pass
+		{
+			lighting off
+			scene_blend add
+			depth_write off
+
+			texture_unit
+			{
+				texture damage.png
+			}
+		}
+	}
+}
+
+material Shield
+{
+	technique
+	{
+		pass
+		{
+			lighting off
+			scene_blend add
+			depth_write off
+
+			texture_unit
+			{
+				texture shield.png
+			}
+		}
+	}
+}
+
+material Cross
+{
+	technique
+	{
+		pass
+		{
+			lighting off
+			scene_blend add
+			depth_write off
+
+			texture_unit
+			{
+				texture cross.png
+			}
+		}
+	}
+}
+
+material Munition
+{
+	technique
+	{
+		pass
+		{
+			lighting off
+			scene_blend add
+			depth_write off
+
+			texture_unit
+			{
+				texture munition.png
+			}
+		}
+	}
+}
+
+material Arrow
+{
+	technique
+	{
+		pass
+		{
+			lighting off
+			scene_blend add
+			depth_write off
+
+			texture_unit
+			{
+				texture arrow.png
+			}
+		}
+	}
+}
+
+material 3arrowsup
+{
+	technique
+	{
+		pass
+		{
+			lighting off
+			scene_blend add
+			depth_write off
+
+			texture_unit
+			{
+				texture 3arrowsup.png
+			}
+		}
+	}
+}
+
+material Eye
+{
+	technique
+	{
+		pass
+		{
+			lighting off
+			scene_blend add
+			depth_write off
+
+			texture_unit
+			{
+				texture eye.png
+			}
+		}
+	}
+}
+
+material Asterisk
+{
+	technique
+	{
+		pass
+		{
+			lighting off
+			scene_blend add
+			depth_write off
+
+			texture_unit
+			{
+				texture asterisk.png
+			}
+		}
+	}
+}
+
+material Shrink
+{
+	technique
+	{
+		pass
+		{
+			lighting off
+			scene_blend add
+			depth_write off
+
+			texture_unit
+			{
+				texture triplespiral.png
+			}
+		}
+	}
+}
+
+material Splash
+{
+	technique
+	{
+		pass
+		{
+			lighting off
+			scene_blend add
+			depth_write off
+
+			texture_unit
+			{
+				texture splash.png
+			}
+		}
+	}
+}
Index: data/trunk/materials/Shield.material
===================================================================
--- data/trunk/materials/Shield.material	(revision 10687)
+++ 	(revision )
@@ -1,17 +1,0 @@
-material Shield
-{
-	technique
-	{
-		pass
-		{
-			lighting off
-			scene_blend add
-			depth_write off
-
-			texture_unit
-			{
-				texture shield.png
-			}
-		}
-	}
-}
Index: data/trunk/materials/Shrink.material
===================================================================
--- data/trunk/materials/Shrink.material	(revision 10687)
+++ 	(revision )
@@ -1,17 +1,0 @@
-material Shrink
-{
-	technique
-	{
-		pass
-		{
-			lighting off
-			scene_blend add
-			depth_write off
-
-			texture_unit
-			{
-				texture triplespiral.png
-			}
-		}
-	}
-}
Index: data/trunk/materials/damageLarge.material
===================================================================
--- data/trunk/materials/damageLarge.material	(revision 10687)
+++ 	(revision )
@@ -1,17 +1,0 @@
-material damageLarge
-{
-	technique
-	{
-		pass
-		{
-			lighting off
-			scene_blend add
-			depth_write off
-
-			texture_unit
-			{
-				texture damageLarge.png
-			}
-		}
-	}
-}
Index: data/trunk/materials/damageMedium.material
===================================================================
--- data/trunk/materials/damageMedium.material	(revision 10687)
+++ 	(revision )
@@ -1,17 +1,0 @@
-material damageMedium
-{
-	technique
-	{
-		pass
-		{
-			lighting off
-			scene_blend add
-			depth_write off
-
-			texture_unit
-			{
-				texture damageMedium.png
-			}
-		}
-	}
-}
Index: data/trunk/materials/damageSmall.material
===================================================================
--- data/trunk/materials/damageSmall.material	(revision 10687)
+++ 	(revision )
@@ -1,17 +1,0 @@
-material damageSmall
-{
-	technique
-	{
-		pass
-		{
-			lighting off
-			scene_blend add
-			depth_write off
-
-			texture_unit
-			{
-				texture damageSmall.png
-			}
-		}
-	}
-}