Index: branches/presentation/src/world_entities/weapons/disruptor.cc
===================================================================
--- branches/presentation/src/world_entities/weapons/disruptor.cc	(revision 10701)
+++ branches/presentation/src/world_entities/weapons/disruptor.cc	(revision 10702)
@@ -38,6 +38,4 @@
  : Weapon()
 {
-//     this->registerObject(this, Disruptor::_objectList);
-
     this->init();
 }
@@ -46,6 +44,4 @@
  : Weapon()
 {
-//     this->registerObject(this, Disruptor::_objectList);
-
     // TODO add leftRight to params
     this->init();
@@ -68,17 +64,5 @@
    delete [] this->shootAnim;
    delete [] this->objComp;
-/*
-    for(int j = 0; j < this->getSegs(); j++)
-    {
-      delete this->shootAnim[i][j];
-      delete this->objComp[i][j];
-    }
-    delete this->shootAnim[i];
-    delete this->objComp[i];
-    delete this->emissionPoint[i];
-  }*/
-
-//  this->deconstr();
-     // model will be deleted from WorldEntity-destructor
+
 }
 
@@ -198,19 +182,20 @@
 void Disruptor::draw() const
 {
-  glMatrixMode(GL_MODELVIEW);
   glPushMatrix();
-  glTranslatef (this->getAbsCoor ().x,
-                this->getAbsCoor ().y,
-                this->getAbsCoor ().z);
-    Vector tmpRot = this->getAbsDir().getSpacialAxis();
-    glRotatef (this->getAbsDir().getSpacialAxisAngle(), tmpRot.x, tmpRot.y, tmpRot.z );
-
-  //Base
-  static_cast<StaticModel*>(this->getModel())->draw(1);
-
-  // Barrel  glPushMatrix();
-  glTranslatef 
-    (this->objComp[0][0]->getAbsCoor().x, this->objComp[0][0]->getAbsCoor().y, this->objComp[0][0]->getAbsCoor().z);
-    static_cast<StaticModel*>(this->getModel())->draw(0);
+    glMatrixMode(GL_MODELVIEW);
+    glTranslatef (this->getAbsCoor ().x,
+                  this->getAbsCoor ().y,
+                  this->getAbsCoor ().z);
+      Vector tmpRot = this->getAbsDir().getSpacialAxis();
+      glRotatef (this->getAbsDir().getSpacialAxisAngle(), tmpRot.x, tmpRot.y, tmpRot.z );
+
+    //Base
+    static_cast<StaticModel*>(this->getModel())->draw(1);
+
+    // Barrel
+    glPushMatrix();
+      glTranslatef(this->objComp[0][0]->getAbsCoor().x, this->objComp[0][0]->getAbsCoor().y, this->objComp[0][0]->getAbsCoor().z);
+      static_cast<StaticModel*>(this->getModel())->draw(0);
+    glPopMatrix();
   glPopMatrix();
 }
Index: branches/presentation/src/world_entities/weapons/nadion_laser.cc
===================================================================
--- branches/presentation/src/world_entities/weapons/nadion_laser.cc	(revision 10701)
+++ branches/presentation/src/world_entities/weapons/nadion_laser.cc	(revision 10702)
@@ -88,5 +88,5 @@
 
   this->setCapability(WTYPE_ALLDIRS | WTYPE_DIRECTIONAL | WTYPE_LIGHT);
-  this->setProjectileTypeC("NadionBlast");   // FIXME temp projectile, until nadion_laser_bolt exists.
+  this->setProjectileTypeC("NadionBlast");
   this->prepareProjectiles(20);
 
@@ -167,12 +167,10 @@
 void NadionLaser::draw() const
 {
+  glPushMatrix();
   glMatrixMode(GL_MODELVIEW);
-  glPushMatrix();
     glTranslatef (this->getAbsCoor ().x, this->getAbsCoor ().y, this->getAbsCoor ().z);
     Vector tmpRot = this->getAbsDir().getSpacialAxis();
     glRotatef (this->getAbsDir().getSpacialAxisAngle(), tmpRot.x, tmpRot.y, tmpRot.z );
     static_cast<StaticModel*>(this->getModel())->draw();
-
-
   glPopMatrix();
 }
Index: branches/presentation/src/world_entities/weapons/rf_cannon.cc
===================================================================
--- branches/presentation/src/world_entities/weapons/rf_cannon.cc	(revision 10701)
+++ branches/presentation/src/world_entities/weapons/rf_cannon.cc	(revision 10702)
@@ -126,22 +126,20 @@
 void RFCannon::fire()
 {
-//   for (int i = 0; i < this->getBarrels(); i++){
-    Projectile* pj =  this->getProjectile();
-    if (pj == NULL)
-      return;
+  Projectile* pj =  this->getProjectile();
+  if (pj == NULL)
+    return;
 
-    // set the owner
-    pj->setOwner(this->getOwner());
+  // set the owner
+  pj->setOwner(this->getOwner());
 
-    pj->setParent(PNode::getNullParent());
+  pj->setParent(PNode::getNullParent());
 
-    pj->setVelocity(this->getAbsDir().apply(Vector(1,0,0))*190);
+  pj->setVelocity(this->getAbsDir().apply(Vector(1,0,0))*190);
 
-    pj->setAbsCoor(this->emissionPoint[this->activeBarrel]->getAbsCoor());
-    pj->setAbsDir(this->getAbsDir());
-    pj->activate();
+  pj->setAbsCoor(this->emissionPoint[this->activeBarrel]->getAbsCoor());
+  pj->setAbsDir(this->getAbsDir());
+  pj->activate();
 
-    this->activeBarrel = (this->activeBarrel + 1) % this->getBarrels();
-//   }
+  this->activeBarrel = (this->activeBarrel + 1) % this->getBarrels();
 }
 
@@ -162,6 +160,6 @@
 void RFCannon::draw() const
 {
-  glMatrixMode(GL_MODELVIEW);
   glPushMatrix();
+    glMatrixMode(GL_MODELVIEW);
     glTranslatef (this->getAbsCoor ().x, this->getAbsCoor ().y, this->getAbsCoor ().z);
     Vector tmpRot = this->getAbsDir().getSpacialAxis();