Index: /code/branches/hoverHS15/data/levels/Hover.oxw
===================================================================
--- /code/branches/hoverHS15/data/levels/Hover.oxw	(revision 10707)
+++ /code/branches/hoverHS15/data/levels/Hover.oxw	(revision 10708)
@@ -36,21 +36,24 @@
   <StaticEntity position="200,0,0" collisionType="static">
     <attached>
-      <Model position="0, 0,0" yaw="90" pitch="-90" roll="0" scale3D="300, 2, 30" mesh="cube_red.mesh" />
-      <Model position="-300, 0,0" yaw="90" pitch="-90" roll="0" scale3D="300, 2, 30" mesh="cube_red.mesh" />      
-      <Model position="-150, 0,150" yaw="90" pitch="-90" roll="0" scale3D="2, 300, 30" mesh="cube_green.mesh" />      
-      <Model position="-150, 0,-150" yaw="90" pitch="-90" roll="0" scale3D="2, 300, 30" mesh="cube_green.mesh" />
+      <Model position="500, 0, 0" yaw="0" pitch="0" roll="0" scale3D="500, 30, 2" mesh="cube_red.mesh" />
+      <Model position="500, 0, 1000" yaw="0" pitch="0" roll="0" scale3D="500, 30, 2" mesh="cube_red.mesh" />      
+      <Model position="0, 0, 500" yaw="0" pitch="0" roll="0" scale3D="2, 30, 500" mesh="cube_green.mesh" />      
+      <Model position="1000, 0, 500" yaw="0" pitch="0" roll="0" scale3D="2, 30, 500" mesh="cube_green.mesh" />
     </attached> 
     <collisionShapes>
-      <BoxCollisionShape yaw="90" pitch="-90" roll="0" position="0,0,0" halfExtents="300, 2, 30" />
-      <BoxCollisionShape yaw="90" pitch="-90" roll="0" position="-300,0,0" halfExtents="300, 2, 30" />
+      <BoxCollisionShape yaw="0" pitch="0" roll="0" position="0,0,0" halfExtents="500, 30, 2" />
+      <BoxCollisionShape yaw="0" pitch="0" roll="0" position="0,0,1000" halfExtents="500, 30, 2" />
+      <BoxCollisionShape yaw="0" pitch="0" roll="0" position="0,0,500" halfExtents="2, 30, 500" />
+      <BoxCollisionShape yaw="0" pitch="0" roll="0" position="1000,500,0" halfExtents="2, 30, 500" />
+
     </collisionShapes>
   </StaticEntity>
 
-  <StaticEntity position="0,-10,0" collisionType="static">
+  <StaticEntity position="0,0,0" collisionType="static">
     <attached>
       <Model position="0, 0,0" yaw="0" pitch="0" roll="0" scale3D="10000, 1, 10000" mesh="CubeGround.mesh" />     
     </attached> 
     <collisionShapes>
-      <BoxCollisionShape yaw="0" pitch="0" roll="0" position="0,0,0" halfExtents="10000, 1, 10000" />
+      <BoxCollisionShape yaw="0" pitch="0" roll="0" position="0,0,0" halfExtents="1, 1, 1" />
     </collisionShapes>
   </StaticEntity>
@@ -59,5 +62,5 @@
     
     <Light type=directional position="0,0,0" direction="0.253, 0.593, -0.765" diffuse="1.0, 0.9, 0.9, 1.0" specular="1.0, 0.9, 0.9, 1.0"/>
-    <SpawnPoint team=0 position="0,0,0" lookat="10,0,0" spawnclass=SpaceShip pawndesign=spaceshippirate />
+    <SpawnPoint team=0 position="0,100,0" lookat="100,100,0" spawnclass=SpaceShip pawndesign=spaceshippirate />
     
   </Scene>
Index: /code/branches/hoverHS15/src/modules/hover/CMakeLists.txt
===================================================================
--- /code/branches/hoverHS15/src/modules/hover/CMakeLists.txt	(revision 10707)
+++ /code/branches/hoverHS15/src/modules/hover/CMakeLists.txt	(revision 10708)
@@ -2,4 +2,5 @@
 Hover.cc
 HoverShip.cc
+HoverWall.cc
 )
 
@@ -8,4 +9,5 @@
   FIND_HEADER_FILES
   LINK_LIBRARIES
+  	objects
     orxonox
     overlays
Index: /code/branches/hoverHS15/src/modules/hover/Hover.cc
===================================================================
--- /code/branches/hoverHS15/src/modules/hover/Hover.cc	(revision 10707)
+++ /code/branches/hoverHS15/src/modules/hover/Hover.cc	(revision 10708)
@@ -34,5 +34,6 @@
 //#include "orxonox/worldentities/pawns/SpaceShip.h"
 #include "Hover.h"
-//#include "HoverShip.h" // Necessary for getPlayer function. Do NOT include this in Header!
+
+#include "HoverWall.h"
 #include "core/CoreIncludes.h"
 
@@ -43,6 +44,7 @@
     Hover::Hover(Context* context) : Gametype(context)
     {
+        
         RegisterObject(Hover);
-
+        new HoverWall(context);
         //this->setHUDTemplate("HoverHUD");
     }
@@ -52,5 +54,4 @@
     void Hover::tick(float dt)
     {
-
         SUPER(Hover, tick, dt);
     }
@@ -61,7 +62,7 @@
     {
 
-
         // Call start for the parent class.
         Gametype::start();
+
     }
 
Index: /code/branches/hoverHS15/src/modules/hover/HoverPrereqs.h
===================================================================
--- /code/branches/hoverHS15/src/modules/hover/HoverPrereqs.h	(revision 10707)
+++ /code/branches/hoverHS15/src/modules/hover/HoverPrereqs.h	(revision 10708)
@@ -70,4 +70,5 @@
     class Hover;
     class HoverShip;
+    class HoverWall;
 }
 